package com.akamai.osmf.samples.presenter
{
	import com.akamai.osmf.samples.view.BaseVideoView;
	
	import org.osmf.events.MediaPlayerCapabilityChangeEvent;
	import org.osmf.media.MediaFactory;
	import org.osmf.media.MediaPlayer;
	
	public class SeekControlBarPresenter extends BaseControlBarPresenter
	{		
		private var startingSeekPerformed:Boolean = false;
		private var startingSeek:int;
		
		public function SeekControlBarPresenter(view:BaseVideoView, mediaPlayer:MediaPlayer, mediaFactory:MediaFactory, mediaResource:String, startingSeek:int)
		{
			super(view, mediaPlayer, mediaFactory, mediaResource);
			this.startingSeek = startingSeek;
		}
		
		override protected function setupMediaPlayerListeners(add:Boolean=true):void
		{
			super.setupMediaPlayerListeners(true);
			
			if (add)
			{
				mediaPlayer.addEventListener(MediaPlayerCapabilityChangeEvent.CAN_SEEK_CHANGE, onCanSeekChange);
			}
			else
			{
				mediaPlayer.removeEventListener(MediaPlayerCapabilityChangeEvent.CAN_SEEK_CHANGE, onCanSeekChange);
			}
		}
		
		protected function onCanSeekChange(event:MediaPlayerCapabilityChangeEvent):void
		{
			if (!startingSeekPerformed && event.enabled && mediaPlayer.media != null)
			{
				startingSeekPerformed = true;
				mediaPlayer.seek(startingSeek);
			}
		}
	}
}
